import React from "react";
import { Tooltip } from "antd";
var wrapTooltip = function wrapTooltip(_ref) {
    var maxWidth = _ref.maxWidth,
        preRender = _ref.preRender,
        renderTooltip = _ref.renderTooltip;
    return function (text, record) {
        for (var _len = arguments.length, restArgs = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            restArgs[_key - 2] = arguments[_key];
        }

        var tooltipTitle = text;
        if (typeof renderTooltip == "function") tooltipTitle = renderTooltip.apply(undefined, [text, record].concat(restArgs));
        return React.createElement(
            Tooltip,
            { placement: "topLeft", title: tooltipTitle },
            React.createElement(
                "div",
                { style: {
                        display: "table-cell",
                        maxWidth: maxWidth,
                        textOverflow: "ellipsis",
                        overflow: "hidden",
                        whiteSpace: "nowrap"
                    } },
                typeof preRender == "function" ? preRender.apply(undefined, [text, record].concat(restArgs)) : text
            )
        );
    };
};
export default wrapTooltip;