/// <reference types="react" />
import React, { Component, ReactNode } from "react";
import { FormProps, GetFieldDecoratorOptions, FormComponentProps } from "antd/lib/form/Form";
import { FormItemProps } from "antd/lib/form/FormItem";
import { ButtonProps } from "antd/lib/button/button";
export declare type FormComponentProps = FormComponentProps;
export interface RFormItemProps extends FormItemProps {
    visible?: boolean;
    itemSpan?: number;
    decorate?: boolean;
    decoratorOptions?: GetFieldDecoratorOptions;
    control: ReactNode;
}
export interface RFormFooter {
    defaultActionAlign?: "left" | "center" | "right";
    defaultActionSpan?: number;
    extraAction?: ReactNode;
    showClear?: boolean;
    clearText?: string;
    submitText?: string;
    submitDisabled?: boolean;
    submitExtraProps?: Partial<ButtonProps>;
    showAdvancedToggle?: boolean;
    advancedToggleTexts?: string[];
    onClear?(): void;
    onSubmit(): void;
    onAdvancedToggle?(prevRenderCount?: number): void;
}
export interface RFormProps extends FormProps {
    background?: "normal";
    header?: ReactNode;
    formItemGutter?: number;
    formItems: RFormItemProps[];
    defaultRenderFormItemCount?: number;
    renderFormItemCount?: number;
    footer?: boolean | RFormFooter;
    onFormChange?(changedFields: any): void;
    onValuesChange?(first: [string, any], values: any): void;
}
export interface RFormState {
    renderCount: number;
}
export declare class RForm extends Component<RFormProps, RFormState> {
    static defaultProps: Partial<RFormProps>;
    constructor(props: RFormProps);
    componentWillReceiveProps({renderFormItemCount}: RFormProps): void;
    onPreClear: () => void;
    renderHeader: () => JSX.Element | null;
    renderFormItems: () => (JSX.Element | null)[];
    onPreAdvancedToggle: () => void;
    renderFooter: () => JSX.Element | null;
    render(): JSX.Element;
}
declare const WrappedForm: React.ComponentClass<Pick<FormComponentProps, never> & RFormProps>;
export default WrappedForm;
