/// <reference types="react" />
import { Component } from "react";
import { RTableProps } from "./../r-table/r-table";
export interface RTableTransferProps<T> {
    sourceRTableProps: RTableProps<T>;
    destinationRTableProps: RTableProps<T>;
    toDesBtnText?: string;
    toSrcBtnText?: string;
    onToDestination(nextSourceRTableDataSource: any[], nextDestinationRTableDataSource: any[]): void;
    onToSource(nextSourceRTableDataSource: any[], nextDestinationRTableDataSource: any[]): void;
}
export interface RTableTransferState {
    sourceRTableSelectedRowKeys: string[];
    sourceRTableSelectedRows: any[];
    destinationRTableSelectedRowKeys: string[];
    destinationRTableSelectedRows: any[];
}
export default class RTableTransfer<T> extends Component<RTableTransferProps<T>, RTableTransferState> {
    static defaultProps: Partial<RTableTransferProps<any>>;
    state: RTableTransferState;
    handleSourceRTableRowSelectionChange: (selectedRowKeys: string[], selectedRows: any[]) => void;
    handleDestinationRTableRowSelectionChange: (selectedRowKeys: string[], selectedRows: any[]) => void;
    handleToDestination: () => void;
    handleToSource: () => void;
    render(): JSX.Element;
}
