import _extends from "babel-runtime/helpers/extends";
import _toConsumableArray from "babel-runtime/helpers/toConsumableArray";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import React, { Component } from "react";
import { Row, Col, Button, Icon } from "antd";
import RTable from "./../r-table/r-table";

var RTableTransfer = function (_Component) {
    _inherits(RTableTransfer, _Component);

    function RTableTransfer() {
        _classCallCheck(this, RTableTransfer);

        var _this = _possibleConstructorReturn(this, (RTableTransfer.__proto__ || Object.getPrototypeOf(RTableTransfer)).apply(this, arguments));

        _this.state = {
            sourceRTableSelectedRowKeys: [],
            sourceRTableSelectedRows: [],
            destinationRTableSelectedRowKeys: [],
            destinationRTableSelectedRows: []
        };
        _this.handleSourceRTableRowSelectionChange = function (selectedRowKeys, selectedRows) {
            _this.setState({
                sourceRTableSelectedRowKeys: selectedRowKeys,
                sourceRTableSelectedRows: selectedRows
            });
        };
        _this.handleDestinationRTableRowSelectionChange = function (selectedRowKeys, selectedRows) {
            _this.setState({
                destinationRTableSelectedRowKeys: selectedRowKeys,
                destinationRTableSelectedRows: selectedRows
            });
        };
        _this.handleToDestination = function () {
            var _this$props = _this.props,
                sourceRTableProps = _this$props.sourceRTableProps,
                destinationRTableProps = _this$props.destinationRTableProps,
                onToDestination = _this$props.onToDestination;
            var _this$state = _this.state,
                sourceRTableSelectedRowKeys = _this$state.sourceRTableSelectedRowKeys,
                sourceRTableSelectedRows = _this$state.sourceRTableSelectedRows;
            var _sourceRTableProps$ro = sourceRTableProps.rowKey,
                srcRowKey = _sourceRTableProps$ro === undefined ? "id" : _sourceRTableProps$ro,
                _sourceRTableProps$da = sourceRTableProps.dataSource,
                srcDS = _sourceRTableProps$da === undefined ? [] : _sourceRTableProps$da;
            var _destinationRTablePro = destinationRTableProps.dataSource,
                desDS = _destinationRTablePro === undefined ? [] : _destinationRTablePro;

            var nextSourceRTableDataSource = srcDS.filter(function (srcObj) {
                return !sourceRTableSelectedRowKeys.includes(srcObj[srcRowKey]);
            });
            onToDestination(nextSourceRTableDataSource, [].concat(_toConsumableArray(desDS), _toConsumableArray(sourceRTableSelectedRows)));
            _this.setState({
                sourceRTableSelectedRowKeys: [],
                sourceRTableSelectedRows: []
            });
        };
        _this.handleToSource = function () {
            var _this$props2 = _this.props,
                sourceRTableProps = _this$props2.sourceRTableProps,
                destinationRTableProps = _this$props2.destinationRTableProps,
                onToSource = _this$props2.onToSource;
            var _this$state2 = _this.state,
                destinationRTableSelectedRowKeys = _this$state2.destinationRTableSelectedRowKeys,
                destinationRTableSelectedRows = _this$state2.destinationRTableSelectedRows;
            var _destinationRTablePro2 = destinationRTableProps.rowKey,
                srcRowKey = _destinationRTablePro2 === undefined ? "id" : _destinationRTablePro2,
                _destinationRTablePro3 = destinationRTableProps.dataSource,
                desDS = _destinationRTablePro3 === undefined ? [] : _destinationRTablePro3;
            var _sourceRTableProps$da2 = sourceRTableProps.dataSource,
                srcDS = _sourceRTableProps$da2 === undefined ? [] : _sourceRTableProps$da2;

            var nextDesRTableDataSource = desDS.filter(function (desObj) {
                return !destinationRTableSelectedRowKeys.includes(desObj[srcRowKey]);
            });
            onToSource([].concat(_toConsumableArray(srcDS), _toConsumableArray(destinationRTableSelectedRows)), nextDesRTableDataSource);
            _this.setState({
                destinationRTableSelectedRowKeys: [],
                destinationRTableSelectedRows: []
            });
        };
        return _this;
    }

    _createClass(RTableTransfer, [{
        key: "render",
        value: function render() {
            var _props = this.props,
                sourceRTableProps = _props.sourceRTableProps,
                destinationRTableProps = _props.destinationRTableProps,
                toDesBtnText = _props.toDesBtnText,
                toSrcBtnText = _props.toSrcBtnText;
            var _state = this.state,
                sourceRTableSelectedRowKeys = _state.sourceRTableSelectedRowKeys,
                destinationRTableSelectedRowKeys = _state.destinationRTableSelectedRowKeys;

            return React.createElement(
                Row,
                { className: "r-antd-r-table-transfer-row" },
                React.createElement(
                    Col,
                    { span: 24 },
                    React.createElement(RTable, _extends({}, sourceRTableProps, { rowSelection: {
                            selectedRowKeys: sourceRTableSelectedRowKeys,
                            onChange: this.handleSourceRTableRowSelectionChange
                        } }))
                ),
                React.createElement(
                    Col,
                    { span: 24 },
                    React.createElement(
                        Button,
                        { onClick: this.handleToDestination },
                        React.createElement(Icon, { type: "down" }),
                        " ",
                        toDesBtnText
                    ),
                    React.createElement(
                        Button,
                        { onClick: this.handleToSource },
                        React.createElement(Icon, { type: "up" }),
                        " ",
                        toSrcBtnText
                    )
                ),
                React.createElement(
                    Col,
                    { span: 24 },
                    React.createElement(RTable, _extends({}, destinationRTableProps, { rowSelection: {
                            selectedRowKeys: destinationRTableSelectedRowKeys,
                            onChange: this.handleDestinationRTableRowSelectionChange
                        } }))
                )
            );
        }
    }]);

    return RTableTransfer;
}(Component);

export default RTableTransfer;

RTableTransfer.defaultProps = {
    toDesBtnText: "To Destination",
    toSrcBtnText: "To Source"
};