"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var wrapTooltip = function wrapTooltip(_ref) {
    var maxWidth = _ref.maxWidth,
        preRender = _ref.preRender,
        renderTooltip = _ref.renderTooltip;
    return function (text, record) {
        for (var _len = arguments.length, restArgs = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            restArgs[_key - 2] = arguments[_key];
        }

        var tooltipTitle = text;
        if (typeof renderTooltip == "function") tooltipTitle = renderTooltip.apply(undefined, [text, record].concat(restArgs));
        return _react2["default"].createElement(
            _antd.Tooltip,
            { placement: "topLeft", title: tooltipTitle },
            _react2["default"].createElement(
                "div",
                { style: {
                        display: "table-cell",
                        maxWidth: maxWidth,
                        textOverflow: "ellipsis",
                        overflow: "hidden",
                        whiteSpace: "nowrap"
                    } },
                typeof preRender == "function" ? preRender.apply(undefined, [text, record].concat(restArgs)) : text
            )
        );
    };
};
exports["default"] = wrapTooltip;
module.exports = exports["default"];