/// <reference types="react" />
import { Component, ReactNode } from "react";
import { MenuProps } from "antd/lib/menu";
export interface MenuItem {
    disabled?: boolean;
    key: string;
    children: ReactNode;
}
export interface ItemGroup {
    title: ReactNode;
    children: MenuItem[];
}
export interface SubMenu {
    disabled?: boolean;
    key: string;
    title: ReactNode;
    onTitleClick?({key, domEvent}: {
        key: any;
        domEvent: any;
    }): void;
}
export interface RMenuItem extends MenuItem {
    type: "menuitem";
}
export interface RItemGroup extends ItemGroup {
    type: "itemgroup";
}
export declare type RSubMenuChild = RMenuItem | RSubMenu | RItemGroup;
export interface RSubMenu extends SubMenu {
    type: "submenu";
    children: RSubMenuChild[];
}
export declare type RMenuChild = RMenuItem | RSubMenu;
export interface RMenuProps extends MenuProps {
    dataSource: RMenuChild[];
}
export declare class RMenu extends Component<RMenuProps, {}> {
    renderMenuItem: ({children, ...rest}: MenuItem) => JSX.Element;
    renderSubMenu: ({children, ...rest}: RSubMenu) => any;
    renderItemGroup: ({children, ...rest}: RItemGroup) => JSX.Element;
    renderSubMenus: (subMenus: RSubMenuChild[]) => any;
    renderMenus: (dataSource: RMenuChild[]) => any[];
    render(): JSX.Element;
}
export default RMenu;
