"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

var _rTable = require("./../r-table/r-table");

var _rTable2 = _interopRequireDefault(_rTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var RTableTransfer = function (_Component) {
    (0, _inherits3["default"])(RTableTransfer, _Component);

    function RTableTransfer() {
        (0, _classCallCheck3["default"])(this, RTableTransfer);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (RTableTransfer.__proto__ || Object.getPrototypeOf(RTableTransfer)).apply(this, arguments));

        _this.state = {
            sourceRTableSelectedRowKeys: [],
            sourceRTableSelectedRows: [],
            destinationRTableSelectedRowKeys: [],
            destinationRTableSelectedRows: []
        };
        _this.handleSourceRTableRowSelectionChange = function (selectedRowKeys, selectedRows) {
            _this.setState({
                sourceRTableSelectedRowKeys: selectedRowKeys,
                sourceRTableSelectedRows: selectedRows
            });
        };
        _this.handleDestinationRTableRowSelectionChange = function (selectedRowKeys, selectedRows) {
            _this.setState({
                destinationRTableSelectedRowKeys: selectedRowKeys,
                destinationRTableSelectedRows: selectedRows
            });
        };
        _this.handleToDestination = function () {
            var _this$props = _this.props,
                sourceRTableProps = _this$props.sourceRTableProps,
                destinationRTableProps = _this$props.destinationRTableProps,
                onToDestination = _this$props.onToDestination;
            var _this$state = _this.state,
                sourceRTableSelectedRowKeys = _this$state.sourceRTableSelectedRowKeys,
                sourceRTableSelectedRows = _this$state.sourceRTableSelectedRows;
            var _sourceRTableProps$ro = sourceRTableProps.rowKey,
                srcRowKey = _sourceRTableProps$ro === undefined ? "id" : _sourceRTableProps$ro,
                _sourceRTableProps$da = sourceRTableProps.dataSource,
                srcDS = _sourceRTableProps$da === undefined ? [] : _sourceRTableProps$da;
            var _destinationRTablePro = destinationRTableProps.dataSource,
                desDS = _destinationRTablePro === undefined ? [] : _destinationRTablePro;

            var nextSourceRTableDataSource = srcDS.filter(function (srcObj) {
                return !sourceRTableSelectedRowKeys.includes(srcObj[srcRowKey]);
            });
            onToDestination(nextSourceRTableDataSource, [].concat((0, _toConsumableArray3["default"])(desDS), (0, _toConsumableArray3["default"])(sourceRTableSelectedRows)));
            _this.setState({
                sourceRTableSelectedRowKeys: [],
                sourceRTableSelectedRows: []
            });
        };
        _this.handleToSource = function () {
            var _this$props2 = _this.props,
                sourceRTableProps = _this$props2.sourceRTableProps,
                destinationRTableProps = _this$props2.destinationRTableProps,
                onToSource = _this$props2.onToSource;
            var _this$state2 = _this.state,
                destinationRTableSelectedRowKeys = _this$state2.destinationRTableSelectedRowKeys,
                destinationRTableSelectedRows = _this$state2.destinationRTableSelectedRows;
            var _destinationRTablePro2 = destinationRTableProps.rowKey,
                srcRowKey = _destinationRTablePro2 === undefined ? "id" : _destinationRTablePro2,
                _destinationRTablePro3 = destinationRTableProps.dataSource,
                desDS = _destinationRTablePro3 === undefined ? [] : _destinationRTablePro3;
            var _sourceRTableProps$da2 = sourceRTableProps.dataSource,
                srcDS = _sourceRTableProps$da2 === undefined ? [] : _sourceRTableProps$da2;

            var nextDesRTableDataSource = desDS.filter(function (desObj) {
                return !destinationRTableSelectedRowKeys.includes(desObj[srcRowKey]);
            });
            onToSource([].concat((0, _toConsumableArray3["default"])(srcDS), (0, _toConsumableArray3["default"])(destinationRTableSelectedRows)), nextDesRTableDataSource);
            _this.setState({
                destinationRTableSelectedRowKeys: [],
                destinationRTableSelectedRows: []
            });
        };
        return _this;
    }

    (0, _createClass3["default"])(RTableTransfer, [{
        key: "render",
        value: function render() {
            var _props = this.props,
                sourceRTableProps = _props.sourceRTableProps,
                destinationRTableProps = _props.destinationRTableProps,
                toDesBtnText = _props.toDesBtnText,
                toSrcBtnText = _props.toSrcBtnText;
            var _state = this.state,
                sourceRTableSelectedRowKeys = _state.sourceRTableSelectedRowKeys,
                destinationRTableSelectedRowKeys = _state.destinationRTableSelectedRowKeys;

            return _react2["default"].createElement(
                _antd.Row,
                { className: "r-antd-r-table-transfer-row" },
                _react2["default"].createElement(
                    _antd.Col,
                    { span: 24 },
                    _react2["default"].createElement(_rTable2["default"], (0, _extends3["default"])({}, sourceRTableProps, { rowSelection: {
                            selectedRowKeys: sourceRTableSelectedRowKeys,
                            onChange: this.handleSourceRTableRowSelectionChange
                        } }))
                ),
                _react2["default"].createElement(
                    _antd.Col,
                    { span: 24 },
                    _react2["default"].createElement(
                        _antd.Button,
                        { onClick: this.handleToDestination },
                        _react2["default"].createElement(_antd.Icon, { type: "down" }),
                        " ",
                        toDesBtnText
                    ),
                    _react2["default"].createElement(
                        _antd.Button,
                        { onClick: this.handleToSource },
                        _react2["default"].createElement(_antd.Icon, { type: "up" }),
                        " ",
                        toSrcBtnText
                    )
                ),
                _react2["default"].createElement(
                    _antd.Col,
                    { span: 24 },
                    _react2["default"].createElement(_rTable2["default"], (0, _extends3["default"])({}, destinationRTableProps, { rowSelection: {
                            selectedRowKeys: destinationRTableSelectedRowKeys,
                            onChange: this.handleDestinationRTableRowSelectionChange
                        } }))
                )
            );
        }
    }]);
    return RTableTransfer;
}(_react.Component);

exports["default"] = RTableTransfer;

RTableTransfer.defaultProps = {
    toDesBtnText: "To Destination",
    toSrcBtnText: "To Source"
};
module.exports = exports["default"];