"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RTable = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _lodash = require("lodash.omit");

var _lodash2 = _interopRequireDefault(_lodash);

var _antd = require("antd");

var _util = require("./../__util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};

var hasFixedColumn = function hasFixedColumn() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.some(function (_ref) {
        var fixed = _ref.fixed;
        return !!fixed;
    });
};
var mapColumns = function mapColumns() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.map(function (column) {
        var _column$tooltip = column.tooltip,
            tooltip = _column$tooltip === undefined ? false : _column$tooltip,
            renderTooltip = column.renderTooltip,
            maxWidth = column.maxWidth,
            width = column.width,
            render = column.render;

        if (!tooltip) return column;
        if (!width && !maxWidth) {
            throw new Error("Ops, width or maxWidth is required when you need wrap tooltip!");
        }
        var nextColumn = (0, _extends3["default"])({}, column, { render: (0, _util.wrapTooltip)({
                maxWidth: Number(maxWidth || width) - 20,
                preRender: render,
                renderTooltip: renderTooltip
            }) });
        return (0, _lodash2["default"])(nextColumn, ["maxWidth", "tooltip", "renderTooltip"]);
    });
};
var removeColumnFixedProps = function removeColumnFixedProps() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    if (!hasFixedColumn(columns)) return columns;
    return columns.map(function (column) {
        if ("fixed" in column) {
            return (0, _lodash2["default"])(column, ["fixed"]);
        }
        return column;
    });
};
var scrollX = function scrollX(props) {
    var _props$columns = props.columns,
        columns = _props$columns === undefined ? [] : _props$columns,
        rowSelection = props.rowSelection,
        expandedRowRender = props.expandedRowRender;
    // const hasFixedColumn = columns.some(({ fixed }) => !!fixed);

    if (!hasFixedColumn(columns)) return;
    var hasCheckbox = false;
    if ((typeof rowSelection === "undefined" ? "undefined" : (0, _typeof3["default"])(rowSelection)) == "object" && rowSelection) hasCheckbox = true;
    var initalWidth = 0;
    if (hasCheckbox) initalWidth += 62;
    if (typeof expandedRowRender == "function") initalWidth += 50;
    var unFixedColumnWidthSum = columns.reduce(function (widthSum, _ref2) {
        var _ref2$width = _ref2.width,
            width = _ref2$width === undefined ? 0 : _ref2$width;
        return widthSum + Number(width);
    }, initalWidth);
    // console.log(unFixedColumnWidthSum);
    return unFixedColumnWidthSum;
};

var RTable = exports.RTable = function (_Component) {
    (0, _inherits3["default"])(RTable, _Component);

    function RTable() {
        (0, _classCallCheck3["default"])(this, RTable);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (RTable.__proto__ || Object.getPrototypeOf(RTable)).apply(this, arguments));

        _this.state = {
            shouldRemoveColumnFixedProps: false
        };
        _this.getPagination = function () {
            var pagination = _this.props.pagination;

            if (typeof pagination == "boolean") return pagination;
            if (!pagination) return false;
            return (0, _extends3["default"])({ showSizeChanger: true, pageSizeOptions: ["6", "10", "20", "50", "100", "500", "1000"], showQuickJumper: true, showTotal: function showTotal(total, _ref3) {
                    var _ref4 = (0, _slicedToArray3["default"])(_ref3, 2),
                        start = _ref4[0],
                        end = _ref4[1];

                    return start + "-" + end + " / " + total;
                } }, pagination);
        };
        return _this;
    }

    (0, _createClass3["default"])(RTable, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            var tableDomNode = (0, _reactDom.findDOMNode)(this.table);
            var xWidth = scrollX(this.props) || 0;
            if (tableDomNode.clientWidth - xWidth > 0) {
                this.setState({ shouldRemoveColumnFixedProps: true });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var _a = this.props,
                _a$fixedMaxWidth = _a.fixedMaxWidth,
                fixedMaxWidth = _a$fixedMaxWidth === undefined ? false : _a$fixedMaxWidth,
                style = _a.style,
                columns = _a.columns,
                scroll = _a.scroll,
                others = __rest(_a, ["fixedMaxWidth", "style", "columns", "scroll"]);var shouldRemoveColumnFixedProps = this.state.shouldRemoveColumnFixedProps;

            var nextColumns = mapColumns(columns);
            if (shouldRemoveColumnFixedProps) {
                nextColumns = removeColumnFixedProps(nextColumns);
            }
            var rest = (0, _lodash2["default"])(others, ["pagination"]);
            if (!others.rowKey) {
                rest = (0, _extends3["default"])({}, rest, { dataSource: (0, _util.insertIndexAsKey)(others.dataSource) });
            }
            var xWidth = scrollX(this.props);
            var defaultStyle = fixedMaxWidth ? { maxWidth: xWidth || "100%" } : {};
            return _react2["default"].createElement(_antd.Table, (0, _extends3["default"])({ ref: function ref(table) {
                    return _this2.table = table;
                }, style: (0, _extends3["default"])({}, style, defaultStyle), size: "middle", columns: nextColumns, pagination: this.getPagination(), scroll: (0, _extends3["default"])({ x: xWidth }, scroll) }, rest));
        }
    }]);
    return RTable;
}(_react.Component);

exports["default"] = RTable;